from pydantic import BaseModel
from datetime import datetime


class PersonModel(BaseModel):
    first_name: str
    last_name: str
    date: datetime


class ReadPersonModel(PersonModel):
    id: int


class UpdatePersonModel(PersonModel):
    id: int


class ResourceModel(BaseModel):
    name: str


class ReadResourceModel(ResourceModel):
    id: int


class UpdateResourceModel(ResourceModel):
    id: int


class RoleModel(BaseModel):
    name: str
    description: str


class ReadRoleModel(RoleModel):
    id: int


class UpdateRoleModel(RoleModel):
    id: int


class PermissionModel(BaseModel):
    name: str
    idResource: int
    idRole: int
    description: str


class ReadPermissionModel(PermissionModel):
    id: int


class UpdatePermissionModel(PermissionModel):
    id: int


class UserAccountModel(BaseModel):
    username: str
    idPerson: int
    idResource: int
    idRole: int
    date: datetime


class ReadUserAccountModel(UserAccountModel):
    id: int


class UpdateUserAccountModel(UserAccountModel):
    id: int
